stages:
  - 🧨unit-tests
  - 🔎code-quality
  - 🔎secure
  - 🐳build
  - 🚢deploy

variables:
  CONTAINER_PORT: 8080
  EXPOSED_PORT: 80

#-----------------------------------------------------------------------------------------
# Includes (remote is possible)
#-----------------------------------------------------------------------------------------
include:
  - '/ci/testing/mocha.gitlab-ci.yml'
  - '/ci/metrics/git-quick-stats.gitlab-ci.yml'
  - '/ci/kaniko/kaniko.gitlab-ci.yml'
  - '/ci/kube/k8s.dsl.yml'
  - '/ci/templates/Code-Quality.gitlab-ci.yml'
  - '/ci/templates/SAST.gitlab-ci.yml'
  - '/ci/templates/Secret-Detection.gitlab-ci.yml'

#-----------------------------------------------------------------------------------------
# Tests
#-----------------------------------------------------------------------------------------
🎯:testing:
  stage: 🧨unit-tests
  extends: .mocha:testing
  rules:
    #- if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

#-----------------------------------------------------------------------------------------
# Quality
#-----------------------------------------------------------------------------------------

# metrics
🤖:git-analysis:
  stage: 🔎code-quality
  extends: .git-quick-stats:analyzer
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

#-----------------------------------------------------------------------------------------
# Docker (Kaniko) builds
#-----------------------------------------------------------------------------------------
🌍:html:build:
  stage: 🐳build
  image: node:13.12-slim
  artifacts:
    paths:
      - ./public/index.html
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
  script:
    - node build.html.js

📦:kaniko:build:
  stage: 🐳build
  extends: .kaniko:builder
  needs: ["🌍:html:build"]
  artifacts:
    paths:
      - ./public/index.html
  rules:
    - if: $CI_COMMIT_BRANCH == "master"

#-----------------------------------------------------------------------------------------
# Deploy
#-----------------------------------------------------------------------------------------
🚀:deploy:
  stage: 🚢deploy
  extends: .k8s:dsl
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
  needs: ["📦:kaniko:build"]
  environment:
    name: ${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
    on_stop: 😢:stop:deploy
  script:
    - generate_manifest
    - cat ./kube/simple.web.app.${CI_COMMIT_SHORT_SHA}.yaml
    - apply
    - scale 3


😢:stop:deploy:
  stage: 🚢deploy
  extends: .k8s:dsl
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: manual
  allow_failure: true
  environment:
    name: ${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    action: stop
  script:
    - generate_manifest
    - delete_deployment


